/**
 * 高拍仪公用js
 */

//var url = "ws://127.0.0.1:12341";
//var url = "ws://localhost:1234";
var url = "ws://localhost:9030";
var websocket;
var connected = false;

/**
 * 初始化webSocket连接
 * @param callback
 * @param value
 * @constructor
 */
function ConnectServer(callback, value) {

    if ('WebSocket' in window) {
        websocket = new WebSocket(url);
    } else if (window.WebSocket) {
        websocket = new WebSocket(url);
    } else if ('MozWebSocket' in window) {
        websocket = new MozWebSocket(url);
    } else {
        alert("浏览器版本太低！请使用Chrome、Firefox、IE10+浏览器！");
    }

    
    websocket.onopen = function () {
        connected = true;
        callback(value);
        //心跳检测重置
        heartCheck.reset().start();
    }
    websocket.onclose = function (e) {
        connected = false;
    }
    websocket.onmessage = function (e) {
        // heartCheck.reset().start();
        // if(e.data !='pong'){
        //     var obj=eval("("+e.data+")");            
        // }

        onMessage(e);
    }
    websocket.onerror = function (e) {
        alert("未连接websocket服务器，请确保已运行服务端！!!!")
    };

}


//心跳检测
var heartCheck = {
    timeout: 1000,
    timeoutObj: null,
    serverTimeoutObj: null,

    reset:  function(){
        clearTimeout(this.timeoutObj);
        clearTimeout(this.serverTimeoutObj);
        return this;

    },
    start: function(){
        console.log('start');
        var self = this;
        this.timeoutObj && clearTimeout(this.timeoutObj);
        this.serverTimeoutObj && clearTimeout(this.serverTimeoutObj);
        this.timeoutObj = setTimeout(function(){
        //这里发送一个心跳，后端收到后，返回一个心跳消息，
        console.log('ping');
        ws.send("ping");
        self.serverTimeoutObj = setTimeout(function() {
            console.log(111);
            console.log(ws);
            ws.close();
            // createWebSocket();
        }, self.timeout);

        }, this.timeout)
    }
    }


/**
 * 接收服务器消息
 * @param e
 */
function onMessage(e) {
    // var jsonObj = eval('(' + e.data + ')');
    var jsonObj = JSON.parse(e.data.replace(/[\r\n]/g,""));
    //通用回调处理函数 jsonObj 遵循文档返回数据格式要求
    produceMessage(jsonObj);
}

/**
 * 向服务器发送信息的共享方法
 * @param jsonStr
 */
function sendMessage(jsonStr) {
    connected ? websocket.send(jsonStr) : alert("未连接websocket服务器，请确保已运行服务端！")
}


/******************* 以下为高拍仪函数 *************************/

function GetCameraInfo(reqId){
    var data = JSON.stringify({'type': 'GetCameraInfo', 'reqId':reqId});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function SetCameraInfo(reqId, devNum, mediaNum, resolutionNum) {
    var data = JSON.stringify({'type': 'SetCameraInfo', 'reqId':reqId, 'devNum':devNum, 'mediaNum':mediaNum,'resolutionNum': resolutionNum});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function GetCameraVideoBuff(reqId, devNum, enable){
    var data = JSON.stringify({'type': 'GetCameraVideoBuff', 'reqId':reqId, 'devNum':devNum, 'enable':enable});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function OpenCamera(reqId, devNum){
    var data = JSON.stringify({'type': 'OpenCamera', 'reqId':reqId, 'devNum':devNum});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function CloseCamera(reqId, devNum){
    var data = JSON.stringify({'type': 'CloseCamera', 'reqId':reqId, 'devNum':devNum});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

function SetCameraImageInfo(reqId, devNum, cropType, imageType, fillBorderType, removalForeign, rotate){
     var data = JSON.stringify({'type': 'SetCameraImageInfo', 'reqId':reqId, 'devNum':devNum, 'cropType':cropType, 'imageType':imageType, 
							  'fillBorderType':fillBorderType,'removalForeign': removalForeign,'rotate': rotate});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function CameraCapture(reqId, devNum, imgPath) {
    var data = JSON.stringify({'type': 'CameraCapture', 'reqId':reqId, 'devNum':devNum, 'imgPath': imgPath});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function CameraCaptureBase(reqId, devNum){
    var data = JSON.stringify({'type': 'CameraCaptureBase64', 'reqId':reqId, 'devNum':devNum});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function UploadCamFile(url,filepath)
{
    var data = JSON.stringify({'type': 'UploadFile', 'url':url, 'filepath':filepath});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/******************* 以下为扫描仪函数 *************************/
function GetScannerName(reqId)
{
    var data = JSON.stringify({'func': 'GetScannerName', 'reqId':reqId});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function OpenScanner(reqId, devNum)
{
    var data = JSON.stringify({'func': 'OpenScanner', 'reqId':reqId, 'devIndex': devNum});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function GetScannerInfo(reqId, devNum)
{
    var data = JSON.stringify({'func': 'GetScannerInfo', 'reqId':reqId, 'devIndex': devNum});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

function CloseScanner(reqId)
{
    var data = JSON.stringify({'func': 'CloseScanner', 'reqId':reqId});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function SetScannerInfo(reqId, scanSource, scanMode, scanResolution, scanPaperSize){
     var data = JSON.stringify({'func': 'SetScannerInfo', 'reqId':reqId, 'scanSource':scanSource, 'scanMode':scanMode, 'scanResolution':scanResolution,
								'scanPaperSize': scanPaperSize});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function SetScannerImageInfo(reqId, cropType, imageType, fillBorderType, removalForeign, rotate){
     var data = JSON.stringify({'func': 'SetScannerImageInfo', 'reqId':reqId, 'cropType':cropType, 'imageType':imageType, 'fillBorderType':fillBorderType,
								'removalForeign': removalForeign, 'rotate': rotate});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function Scan(reqId, devNum, scanSource, scanMode, scanResolution, scanPaperSize)
{
    var data = JSON.stringify({'func': 'Scan', 'reqId':reqId, 'devIndex': devNum, 'scanSource':scanSource, 'scanMode':scanMode, 
                                'scanResolution':scanResolution,'scanPaperSize': scanPaperSize});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}


/******************* 以下为读卡器函数 *************************/
function ReadIDCardInfo(reqId, idType)
{
    var data = JSON.stringify({'func': 'ReadIDCardInfo', 'reqId':reqId, 'idType':idType});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}


